﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Office.Interop.Visio;
using System.Windows;

namespace WpfApp1
{
    class VisioHelper
    {
        private Page m_page;
        private Master m_master;
        private Document m_document;
        private Shape connector;

        private void ConnectTogether(int BeginID,int EndID)
        {
            //添加动态连接线
            connector = m_page.Drop(m_document.Masters["动态连接线"], 4.50, 4.50);
            //将动态连接线设置为直线，关键是要知道FormulaU这个属性，16表示是直线
            connector.get_CellsSRC((short)VisSectionIndices.visSectionObject, (short)VisRowIndices.visRowShapeLayout, (short)VisCellIndices.visSLORouteStyle).FormulaU = "16";
            //获取动态连接线的始端
            Cell beginXCell = connector.get_CellsSRC((short)VisSectionIndices.visSectionObject, (short)VisRowIndices.visRowXForm1D, (short)VisCellIndices.vis1DBeginX);
            //获取第一个矩形的连接点
            Cell FirstRectangleBeginPoint = m_page.Shapes.get_ItemFromID(BeginID).get_CellsSRC((short)VisSectionIndices.visSectionObject, (short)VisRowIndices.visRowXFormOut, (short)VisCellIndices.visXFormPinX);
            //动态连接线的始端与第一个矩形的连接点连接
            beginXCell.GlueTo(FirstRectangleBeginPoint);
            //获取动态连接线的末端
            Cell endXCell = connector.get_CellsSRC((short)VisSectionIndices.visSectionObject, (short)VisRowIndices.visRowXForm1D, (short)VisCellIndices.vis1DEndX);
            //获取第二个矩形的连接点
            Cell ShapeConnectorEndPoint = m_page.Shapes.get_ItemFromID(EndID).get_CellsSRC((short)VisSectionIndices.visSectionObject, (short)VisRowIndices.visRowXFormOut, (short)VisCellIndices.visXFormPinX);
            //动态连接线的末端与第二个矩形的连接点连接
            endXCell.GlueTo(ShapeConnectorEndPoint);
        }

        public void DrawVisio()
        {
            Microsoft.Office.Interop.Visio.Application m_app = new Microsoft.Office.Interop.Visio.Application();
            m_document = m_app.Documents.Add("");
            m_document = m_app.Documents.OpenEx("WALL_M.vss", (short)VisOpenSaveArgs.visOpenDocked);
            m_page = m_app.ActivePage;
            //添加第一个矩形
            //m_master = m_document.Masters.get_ItemU(@"Rectangle");
            //Shape m_sp1 = m_page.DrawRectangle(0.0, 0.0,3.0,3.0);
            //m_sp1.Text = @"第一个矩形";
            ////添加第二个矩形
            //m_master = m_document.Masters.get_ItemU(@"Rectangle");
            //Shape m_sp2 = m_page.DrawRectangle(2.0,2.0,1.0,1.0);
            //m_sp2.Text = @"第二个矩形";
            m_master = m_document.Masters["外墙"];
            Shape m_sp3 = m_page.Drop(m_master, 1.0, 1.0);
            m_sp3.get_CellsSRC((short)VisSectionIndices.visSectionObject, (short)VisRowIndices.visRowFill, (short)VisCellIndices.visFillForegnd).FormulaU = "RGB(0,0,0)";
            m_sp3.SetBegin(1.0, 1.0);
            m_sp3.SetEnd(1.0, 5.0);
            m_sp3.Cells["Prop.T"].Formula = "300mm";
            m_sp3.Cells["Prop.VisWallLength"].Formula = "8m";
            //var i = m_sp3.Style;
            //var i = m_sp3.get_CellsSRC((short)VisSectionIndices.visSectionObject, (short)VisRowIndices.visRowFill, (short)VisCellIndices.visFillBkgnd).get_ResultStr(VisUnitCodes.visUnitsColor);
            //Cell cell = m_sp3.get_CellsSRC((short)VisSectionIndices.visSectionObject, (short)VisRowIndices.visRowFill, (short)VisCellIndices.visFillBkgnd);
            //cell.Formula = "RGB(0,0,0)";

            m_master = m_document.Masters["房间"];
            Shape m_sp4 = m_page.Drop(m_master, 5.0, 5.0);
            //m_sp4.get_CellsSRC((short)VisSectionIndices.visSectionObject, (short)VisRowIndices.visRowFill, (short)VisCellIndices.visFillForegnd).FormulaU = "THEMEGUARD(RGB(0,0,0))";
            m_sp4.Cells["FillForegnd"].Formula = "RGB(0,0,0)";
            m_sp4.Cells["Prop.Width"].Formula = "4m";            
            //var m = m_sp4.Style;
            m_page.Layout();
            //调用ConnectTogether方法，参数是两个矩形的id号，这里要说的是，visio中添加的第1个图形，id号是1，第二个是2，依此类推。。。
            //ConnectTogether(1, 2);
            //保存
            //m_document.SaveAs(@"C:\\b.vsd");
            //m_document.Close();
            //m_app.Quit();
            Console.WriteLine(m_sp4.Cells["Prop.Width"].Formula.ToString());
            Console.WriteLine(m_sp4.Cells["FillForegnd"].Formula.ToString());
        }
    }
}
